Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jgrapht.graph
Class DefaultListenableGraph<V,E>

    java.lang.Object
      org.jgrapht.graph.AbstractGraph<V,E>
          org.jgrapht.graph.GraphDelegator<V,E>
              org.jgrapht.graph.DefaultListenableGraph<V,E>

All Implemented Interfaces:
  java.io.Serializable, java.lang.Cloneable, Graph<V,E>, ListenableGraph<V,E>

Direct Known Subclasses:
  ListenableDirectedGraph, ListenableUndirectedGraph

    public class DefaultListenableGraph<V,E>

extends GraphDelegator<V,E>
implements ListenableGraph<V,E>, java.lang.Cloneable

A graph backed by the the graph specified at the constructor, which can be listened by `GraphListener` s and by `VertexSetListener` s. Operations on this graph "pass through" to the to the backing graph. Any modification made to this graph or the backing graph is reflected by the other.

This graph does not pass the hashCode and equals operations through to the backing graph, but relies on `Object`'s `equals` and `hashCode` methods.

Since:
  Jul 20, 2003
Author:
  Barak Naveh
See Also:
  `GraphListener`, `VertexSetListener`, Serialized Form

Constructor Summary
`DefaultListenableGraph(Graph<V,E> g)` Creates a new listenable graph.
`DefaultListenableGraph(Graph<V,E> g, boolean reuseEvents)` Creates a new listenable graph.

Method Summary
`E` | `addEdge(V sourceVertex, V targetVertex)` Creates a new edge in this graph, going from the source vertex to the target vertex, and returns the created edge.
`boolean` | `addEdge(V sourceVertex, V targetVertex, E e)` Adds the specified edge to this graph, going from the source vertex to the target vertex.
`void` | `addGraphListener(GraphListener<V,E> l)` Adds the specified graph listener to this graph, if not already present.
`boolean` | `addVertex(V v)` Adds the specified vertex to this graph if not already present.
`void` | `addVertexSetListener(VertexSetListener<V> l)` Adds the specified vertex set listener to this graph, if not already present.
`java.lang.Object` | `clone()`
`protected void` | `fireEdgeAdded(E edge)` Notify listeners that the specified edge was added.
`protected void` | `fireEdgeRemoved(E edge)` Notify listeners that the specified edge was removed.
`protected void` | `fireVertexAdded(V vertex)` Notify listeners that the specified vertex was added.
`protected void` | `fireVertexRemoved(V vertex)` Notify listeners that the specified vertex was removed.
`boolean` | `isReuseEvents()` Tests whether the `reuseEvents` flag is set.
`boolean` | `removeEdge(E e)` Removes the specified edge from the graph.
`E` | `removeEdge(V sourceVertex, V targetVertex)` Removes an edge going from source vertex to target vertex, if such vertices and such edge exist in this graph.
`void` | `removeGraphListener(GraphListener<V,E> l)` Removes the specified graph listener from this graph, if present.
`boolean` | `removeVertex(V v)` Removes the specified vertex from this graph including all its touching edges if present.
`void` | `removeVertexSetListener(VertexSetListener<V> l)` Removes the specified vertex set listener from this graph, if present.
`void` | `setReuseEvents(boolean reuseEvents)` If the `reuseEvents` flag is set to `true` this class will reuse previously fired events and will not create a new object for each event.

Methods inherited from class org.jgrapht.graph.GraphDelegator
`containsEdge, containsVertex, degreeOf, edgeSet, edgesOf, getAllEdges, getEdge, getEdgeFactory, getEdgeSource, getEdgeTarget, getEdgeWeight, incomingEdgesOf, inDegreeOf, outDegreeOf, outgoingEdgesOf, setEdgeWeight, toString, vertexSet`

Methods inherited from class org.jgrapht.graph.AbstractGraph
`assertVertexExist, containsEdge, removeAllEdges, removeAllEdges, removeAllEdges, removeAllVertices, toStringFromSets`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.jgrapht.Graph
`containsEdge, containsEdge, containsVertex, edgeSet, edgesOf, getAllEdges, getEdge, getEdgeFactory, getEdgeSource, getEdgeTarget, getEdgeWeight, removeAllEdges, removeAllEdges, removeAllVertices, vertexSet`

Constructor Detail

### DefaultListenableGraph

    public DefaultListenableGraph(Graph<V,E> g)

  Creates a new listenable graph.

  Parameters:
    `g` - the backing graph.

### DefaultListenableGraph

    public DefaultListenableGraph(Graph<V,E> g,
                                  boolean reuseEvents)

  Creates a new listenable graph. If the `reuseEvents` flag is set to `true` this class will reuse previously fired events and will not create a new object for each event. This option increases performance but should be used with care, especially in multithreaded environment.

  Parameters:
    `g` - the backing graph.
    `reuseEvents` - whether to reuse previously fired event objects instead of creating a new event object for each event.
  Throws:
    `java.lang.IllegalArgumentException` - if the backing graph is already a listenable graph.

Method Detail

### setReuseEvents

    public void setReuseEvents(boolean reuseEvents)

  If the `reuseEvents` flag is set to `true` this class will reuse previously fired events and will not create a new object for each event. This option increases performance but should be used with care, especially in multithreaded environment.

  Parameters:
    `reuseEvents` - whether to reuse previously fired event objects instead of creating a new event object for each event.

### isReuseEvents

    public boolean isReuseEvents()

  Tests whether the `reuseEvents` flag is set. If the flag is set to `true` this class will reuse previously fired events and will not create a new object for each event. This option increases performance but should be used with care, especially in multithreaded environment.

  Returns:
    the value of the `reuseEvents` flag.

### addEdge

    public E addEdge(V sourceVertex,
                     V targetVertex)

  Description copied from interface: `Graph`
  Creates a new edge in this graph, going from the source vertex to the target vertex, and returns the created edge. Some graphs do not allow edge-multiplicity. In such cases, if the graph already contains an edge from the specified source to the specified target, than this method does not change the graph and returns `null`.

  The source and target vertices must already be contained in this graph. If they are not found in graph IllegalArgumentException is thrown.

  This method creates the new edge `e` using this graph's `EdgeFactory`. For the new edge to be added `e` must not be equal to any other edge the graph (even if the graph allows edge-multiplicity). More formally, the graph must not contain any edge `e2` such that `e2.equals(e)`. If such `e2` is found then the newly created edge `e` is abandoned, the method leaves this graph unchanged returns `null`.

  Specified by:
    `addEdge` in interface `Graph<V,E>`
  Overrides:
    `addEdge` in class `GraphDelegator<V,E>`
  Parameters:
    `sourceVertex` - source vertex of the edge.
    `targetVertex` - target vertex of the edge.
  Returns:
    The newly created edge if added to the graph, otherwise `null`.
  See Also:
    `Graph.addEdge(Object, Object)`

### addEdge

    public boolean addEdge(V sourceVertex,
                           V targetVertex,
                           E e)

  Description copied from interface: `Graph`
  Adds the specified edge to this graph, going from the source vertex to the target vertex. More formally, adds the specified edge, `e`, to this graph if this graph contains no edge `e2` such that `e2.equals(e)`. If this graph already contains such an edge, the call leaves this graph unchanged and returns `false`. Some graphs do not allow edge-multiplicity. In such cases, if the graph already contains an edge from the specified source to the specified target, than this method does not change the graph and returns `false`. If the edge was added to the graph, returns `true`.

  The source and target vertices must already be contained in this graph. If they are not found in graph IllegalArgumentException is thrown.

  Specified by:
    `addEdge` in interface `Graph<V,E>`
  Overrides:
    `addEdge` in class `GraphDelegator<V,E>`
  Parameters:
    `sourceVertex` - source vertex of the edge.
    `targetVertex` - target vertex of the edge.
    `e` - edge to be added to this graph.
  Returns:
    `true` if this graph did not already contain the specified edge.
  See Also:
    `Graph.addEdge(Object, Object, Object)`

### addGraphListener

    public void addGraphListener(GraphListener<V,E> l)

  Description copied from interface: `ListenableGraph`
  Adds the specified graph listener to this graph, if not already present.

  Specified by:
    `addGraphListener` in interface `ListenableGraph<V,E>`
  Parameters:
    `l` - the listener to be added.
  See Also:
    `ListenableGraph.addGraphListener(GraphListener)`

### addVertex

    public boolean addVertex(V v)

  Description copied from interface: `Graph`
  Adds the specified vertex to this graph if not already present. More formally, adds the specified vertex, `v`, to this graph if this graph contains no vertex `u` such that `u.equals(v)`. If this graph already contains such vertex, the call leaves this graph unchanged and returns `false`. In combination with the restriction on constructors, this ensures that graphs never contain duplicate vertices.

  Specified by:
    `addVertex` in interface `Graph<V,E>`
  Overrides:
    `addVertex` in class `GraphDelegator<V,E>`
  Parameters:
    `v` - vertex to be added to this graph.
  Returns:
    `true` if this graph did not already contain the specified vertex.
  See Also:
    `Graph.addVertex(Object)`

### addVertexSetListener

    public void addVertexSetListener(VertexSetListener<V> l)

  Description copied from interface: `ListenableGraph`
  Adds the specified vertex set listener to this graph, if not already present.

  Specified by:
    `addVertexSetListener` in interface `ListenableGraph<V,E>`
  Parameters:
    `l` - the listener to be added.
  See Also:
    `ListenableGraph.addVertexSetListener(VertexSetListener)`

### clone

    public java.lang.Object clone()

  Overrides:
    `clone` in class `java.lang.Object`
  See Also:
    `Object.clone()`

### removeEdge

    public E removeEdge(V sourceVertex,
                        V targetVertex)

  Description copied from interface: `Graph`
  Removes an edge going from source vertex to target vertex, if such vertices and such edge exist in this graph. Returns the edge if removed or `null` otherwise.

  Specified by:
    `removeEdge` in interface `Graph<V,E>`
  Overrides:
    `removeEdge` in class `GraphDelegator<V,E>`
  Parameters:
    `sourceVertex` - source vertex of the edge.
    `targetVertex` - target vertex of the edge.
  Returns:
    The removed edge, or `null` if no edge removed.
  See Also:
    `Graph.removeEdge(Object, Object)`

### removeEdge

    public boolean removeEdge(E e)

  Description copied from interface: `Graph`
  Removes the specified edge from the graph. Removes the specified edge from this graph if it is present. More formally, removes an edge `e2` such that `e2.equals(e)`, if the graph contains such edge. Returns `true` if the graph contained the specified edge. (The graph will not contain the specified edge once the call returns).

  If the specified edge is `null` returns `false`.

  Specified by:
    `removeEdge` in interface `Graph<V,E>`
  Overrides:
    `removeEdge` in class `GraphDelegator<V,E>`
  Parameters:
    `e` - edge to be removed from this graph, if present.
  Returns:
    `true` if and only if the graph contained the specified edge.
  See Also:
    `Graph.removeEdge(Object)`

### removeGraphListener

    public void removeGraphListener(GraphListener<V,E> l)

  Description copied from interface: `ListenableGraph`
  Removes the specified graph listener from this graph, if present.

  Specified by:
    `removeGraphListener` in interface `ListenableGraph<V,E>`
  Parameters:
    `l` - the listener to be removed.
  See Also:
    `ListenableGraph.removeGraphListener(GraphListener)`

### removeVertex

    public boolean removeVertex(V v)

  Description copied from interface: `Graph`
  Removes the specified vertex from this graph including all its touching edges if present. More formally, if the graph contains a vertex `u` such that `u.equals(v)`, the call removes all edges that touch `u` and then removes `u` itself. If no such `u` is found, the call leaves the graph unchanged. Returns `true` if the graph contained the specified vertex. (The graph will not contain the specified vertex once the call returns).

  If the specified vertex is `null` returns `false`.

  Specified by:
    `removeVertex` in interface `Graph<V,E>`
  Overrides:
    `removeVertex` in class `GraphDelegator<V,E>`
  Parameters:
    `v` - vertex to be removed from this graph, if present.
  Returns:
    `true` if the graph contained the specified vertex; `false` otherwise.
  See Also:
    `Graph.removeVertex(Object)`

### removeVertexSetListener

    public void removeVertexSetListener(VertexSetListener<V> l)

  Description copied from interface: `ListenableGraph`
  Removes the specified vertex set listener from this graph, if present.

  Specified by:
    `removeVertexSetListener` in interface `ListenableGraph<V,E>`
  Parameters:
    `l` - the listener to be removed.
  See Also:
    `ListenableGraph.removeVertexSetListener(VertexSetListener)`

### fireEdgeAdded

    protected void fireEdgeAdded(E edge)

  Notify listeners that the specified edge was added.

  Parameters:
    `edge` - the edge that was added.

### fireEdgeRemoved

    protected void fireEdgeRemoved(E edge)

  Notify listeners that the specified edge was removed.

  Parameters:
    `edge` - the edge that was removed.

### fireVertexAdded

    protected void fireVertexAdded(V vertex)

  Notify listeners that the specified vertex was added.

  Parameters:
    `vertex` - the vertex that was added.

### fireVertexRemoved

    protected void fireVertexRemoved(V vertex)

  Notify listeners that the specified vertex was removed.

  Parameters:
    `vertex` - the vertex that was removed.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD